prognameA=encoder
prognameB=decoder
CXX=g++
CXXFLAGS=-Wall -Wextra -Werror -std=c++03 -g3

TEST_INPUTS:=$(wildcard test*.input)
SOURCES:=$(wildcard *.cpp)
PREPROCS:=$(patsubst %.cpp,%.ii,$(SOURCES))
ASSEMBLES:=$(patsubst %.cpp,%.s,$(SOURCES))
OBJS:=$(patsubst %.cpp,%.o,$(SOURCES))
TESTS:=$(patsubst %.input,%,$(TEST_INPUTS))

qa: $(TESTS)

test%: $(prognameA) $(prognameB)
	@echo "Running $@..."
	@./$(prognameA) < $@.input | ./$(prognameB) > $@.output || echo "Negative case..."
	@diff $@.output $@.input > /dev/null && echo "$@ PASSED" || echo "$@ FAILED"

$(prognameA): $(prognameA).o | .gitignore
	$(CXX) $(CXXFLAGS) $^ -o $@

$(prognameB): $(prognameB).o | .gitignore
	$(CXX) $(CXXFLAGS) $^ -o $@

%.ii: %.cpp
	$(CXX) $(CXXFLAGS) -E $< -o $@

%.s: %.ii
	$(CXX) $(CXXFLAGS) -S $< -o $@

%.o: %.s
	$(CXX) $(CXXFLAGS) -c $< -o $@

.gitignore:
	echo $(progname) > $@

clean:
	rm -rf *.ii *.s *.o *.output $(prognameA) $(prognameB)

.PRECIOUS: $(PREPROCS) $(ASSEMBLES)
.SECONDARY: $(PREPROCS) $(ASSEMBLES)

